searchNodes=[{"doc":"NiceMaps provides a single function parse to convert maps into the desired format. It can build camelcase/snake_case keys, convert string keys to atom keys and vice versa, or convert structs to maps","ref":"NiceMaps.html","title":"NiceMaps","type":"module"},{"doc":"The main interface - this is where the magic happens. Options :keys one of :camelcase or :snake_case :convert_structs one of true or false, default: false :key_type, one of :string, :existing_atom, or :unsave_atom (please use :existing_atom whenever possible) Examples Without Options: iex&gt; NiceMaps.parse(%MyStruct{id: 1, my_key: &quot;bar&quot;}) %{id: 1, my_key: &quot;bar&quot;} iex&gt; NiceMaps.parse([%MyStruct{id: 1, my_key: &quot;bar&quot;}, %{value: &quot;a&quot;}]) [%{id: 1, my_key: &quot;bar&quot;}, %{value: &quot;a&quot;}] iex&gt; NiceMaps.parse([%MyStruct{id: 1, my_key: &quot;bar&quot;}, &quot;String&quot;]) [%{id: 1, my_key: &quot;bar&quot;}, &quot;String&quot;] iex&gt; NiceMaps.parse(%{0 =&gt; &quot;0&quot;, 1 =&gt; &quot;1&quot;}) %{0 =&gt; &quot;0&quot;, 1 =&gt; &quot;1&quot;} Keys to camelcase: iex&gt; NiceMaps.parse([%MyStruct{id: 1, my_key: &quot;bar&quot;}, %{value: &quot;a&quot;}], keys: :camelcase) [%{id: 1, myKey: &quot;bar&quot;}, %{value: &quot;a&quot;}] iex&gt; NiceMaps.parse(%MyStruct{id: 1, my_key: &quot;foo&quot;}, keys: :camelcase) %{id: 1, myKey: &quot;foo&quot;} iex&gt; NiceMaps.parse(%{&quot;string&quot; =&gt; &quot;value&quot;, &quot;another_string&quot; =&gt; &quot;value&quot;}, keys: :camelcase) %{&quot;string&quot; =&gt; &quot;value&quot;, &quot;anotherString&quot; =&gt; &quot;value&quot;} # Keys to snake case: iex&gt; NiceMaps.parse(%MyCamelStruct{id: 1, myKey: &quot;foo&quot;}, keys: :snake_case) %{id: 1, my_key: &quot;foo&quot;} iex&gt; NiceMaps.parse(%MyCamelStruct{id: 1, myKey: &quot;foo&quot;}, keys: :snake_case) %{id: 1, my_key: &quot;foo&quot;} iex&gt; NiceMaps.parse(%{&quot;string&quot; =&gt; &quot;value&quot;, &quot;another_string&quot; =&gt; &quot;value&quot;}, keys: :camelcase) %{&quot;string&quot; =&gt; &quot;value&quot;, &quot;anotherString&quot; =&gt; &quot;value&quot;} Convert all structs into maps iex&gt; map = %{ ...&gt; list: [ ...&gt; %MyStruct{id: 1, my_key: &quot;foo&quot;} ...&gt; ], ...&gt; struct: %MyStruct{id: 2, my_key: &quot;bar&quot;}, ...&gt; other_struct: %MyStruct{id: 3, my_key: %MyStruct{id: 4, my_key: nil}} ...&gt; } ...&gt; NiceMaps.parse(map, convert_structs: true) %{ list: [ %{id: 1, my_key: &quot;foo&quot;} ], struct: %{id: 2, my_key: &quot;bar&quot;}, other_struct: %{id: 3, my_key: %{id: 4, my_key: nil}} } Convert string keys to existing atom iex&gt; map = %{ ...&gt; &quot;key1&quot; =&gt; &quot;value 1&quot;, ...&gt; &quot;nested&quot; =&gt; %{&quot;key2&quot; =&gt; &quot;value 2&quot;}, ...&gt; &quot;list&quot; =&gt; [%{&quot;key3&quot; =&gt; &quot;value 3&quot;, &quot;key4&quot; =&gt; &quot;value 4&quot;}], ...&gt; 1 =&gt; &quot;an integer key&quot;, ...&gt; %MyStruct{} =&gt; &quot;a struct key&quot; ...&gt; } iex&gt; [:key1, :key2, :key3, :key4, :nested, :list] # Make sure atoms exist iex&gt; NiceMaps.parse(map, key_type: :existing_atom) %{ :key1 =&gt; &quot;value 1&quot;, :nested =&gt; %{key2: &quot;value 2&quot;}, :list =&gt; [%{key3: &quot;value 3&quot;, key4: &quot;value 4&quot;}], 1 =&gt; &quot;an integer key&quot;, %MyStruct{} =&gt; &quot;a struct key&quot; } Mix it all together iex&gt; map = %{ ...&gt; &quot;hello_there&quot; =&gt; [%{&quot;aA&quot; =&gt; &quot;asdf&quot;}, %{&quot;a_a&quot; =&gt; &quot;bhjk&quot;}, &quot;a string&quot;, 1], ...&gt; thingA: &quot;thing A&quot;, ...&gt; thing_b: &quot;thing B&quot; ...&gt; } iex&gt; NiceMaps.parse(map, keys: :camelcase, key_type: :string) %{&quot;helloThere&quot; =&gt; [%{&quot;aA&quot; =&gt; &quot;asdf&quot;}, %{&quot;aA&quot; =&gt; &quot;bhjk&quot;}, &quot;a string&quot;, 1], &quot;thingA&quot; =&gt; &quot;thing A&quot;, &quot;thingB&quot; =&gt; &quot;thing B&quot;} iex&gt; map = %{ ...&gt; &quot;helloThere&quot; =&gt; [%{&quot;aA&quot; =&gt; &quot;asdf&quot;}, %{&quot;a_a&quot; =&gt; &quot;bhjk&quot;}, &quot;a string&quot;, 1], ...&gt; thingA: &quot;thing A&quot;, ...&gt; thing_b: &quot;thing B&quot; ...&gt; } iex&gt; [:hello_there, :thing_a, :thing_b] # make sure atoms exist iex&gt; NiceMaps.parse(map, keys: :snake_case, key_type: :existing_atom) %{:hello_there =&gt; [%{:a_a =&gt; &quot;asdf&quot;}, %{:a_a =&gt; &quot;bhjk&quot;}, &quot;a string&quot;, 1], :thing_a =&gt; &quot;thing A&quot;, :thing_b =&gt; &quot;thing B&quot;}","ref":"NiceMaps.html#parse/2","title":"NiceMaps.parse/2","type":"function"}]